var command = "";

  function insertNodeAtSelection(win, insertNode)
  {
      // get current selection
      var sel = win.getSelection();

      // get the first range of the selection
      // (there's almost always only one range)
      var range = sel.getRangeAt(0);

      // deselect everything
      sel.removeAllRanges();

      // remove content of current selection from document
      range.deleteContents();

      // get location of current selection
      var container = range.startContainer;
      var pos = range.startOffset;

      // make a new range for the new selection
      range=document.createRange();

      if (container.nodeType==3 && insertNode.nodeType==3) {

        // if we insert text in a textnode, do optimized insertion
        container.insertData(pos, insertNode.nodeValue);

        // put cursor after inserted text
        range.setEnd(container, pos+insertNode.length);
        range.setStart(container, pos+insertNode.length);

      } else {


        var afterNode;
        if (container.nodeType==3) {

          // when inserting into a textnode
          // we create 2 new textnodes
          // and put the insertNode in between

          var textNode = container;
          container = textNode.parentNode;
          var text = textNode.nodeValue;

          // text before the split
          var textBefore = text.substr(0,pos);
          // text after the split
          var textAfter = text.substr(pos);

          var beforeNode = document.createTextNode(textBefore);
          var afterNode = document.createTextNode(textAfter);

          // insert the 3 new nodes before the old one
          container.insertBefore(afterNode, textNode);
          container.insertBefore(insertNode, afterNode);
          container.insertBefore(beforeNode, insertNode);

          // remove the old node
          container.removeChild(textNode);

        } else {

          // else simply insert the node
          afterNode = container.childNodes[pos];
          container.insertBefore(insertNode, afterNode);
        }

        range.setEnd(afterNode, 0);
        range.setStart(afterNode, 0);
      }

      sel.addRange(range);
  };

function getOffsetTop(elm) {

  var mOffsetTop = elm.offsetTop;
  var mOffsetParent = elm.offsetParent;

  while(mOffsetParent){
    mOffsetTop += mOffsetParent.offsetTop;
    mOffsetParent = mOffsetParent.offsetParent;
  }
 
  return mOffsetTop;
}

function getOffsetLeft(elm) {

  var mOffsetLeft = elm.offsetLeft;
  var mOffsetParent = elm.offsetParent;

  while(mOffsetParent){
    mOffsetLeft += mOffsetParent.offsetLeft;
    mOffsetParent = mOffsetParent.offsetParent;
  }
 
  return mOffsetLeft;
}

function tbclick(command)
{
 dump("EDITOR: running " + command + "\n");
 document.getElementById('edit-box').contentWindow.focus();
 if (command == "createlink") {
    var szURL = prompt("Enter a URL:", "");
    document.getElementById('edit-box').contentWindow.document.execCommand("CreateLink",false,szURL)
  } else if (command == "createtable") {
    e = document.getElementById("edit-box");
    rowstext = prompt("enter rows");
    colstext = prompt("enter cols");
    rows = parseInt(rowstext);
    cols = parseInt(colstext);
    if ((rows > 0) && (cols > 0)) {
      table = e.contentWindow.document.createElement("table");
      table.setAttribute("border", "1");
      table.setAttribute("cellpadding", "2");
      table.setAttribute("cellspacing", "2");
      tbody = e.contentWindow.document.createElement("tbody");
      for (var i=0; i < rows; i++) {
        tr =e.contentWindow.document.createElement("tr");
        for (var j=0; j < cols; j++) {
          td =e.contentWindow.document.createElement("td");
          br =e.contentWindow.document.createElement("br");
          td.appendChild(br);
          tr.appendChild(td);
        }
        tbody.appendChild(tr);
      }
      table.appendChild(tbody);      
      insertNodeAtSelection(e.contentWindow, table);
    }
  } else {
    document.getElementById('edit-box').contentWindow.document.execCommand(command, false, null);
  }
}

function Select(selectname)
{
  var cursel = document.getElementById(selectname).selectedIndex;
  /* First one is always a label */
  if (cursel != 0) {
    var selected = document.getElementById(selectname).options[cursel].value;
    document.getElementById('edit-box').contentWindow.document.execCommand(selectname, false, selected);
    document.getElementById(selectname).selectedIndex = 0;
  }
  document.getElementById("edit-box").contentWindow.focus();
}

function dismisscolorpalette()
{
  //document.getElementById("colorpalette").style.visibility="hidden";
}

function Start() {
  document.getElementById('edit-box').contentWindow.document.designMode = "on";
  try {
    document.getElementById('edit-box').contentWindow.document.execCommand("undo", false, null);
  }  catch (e) {
    alert("This demo is not supported on your level of Mozilla.");
  }

  //InitToolbarButtons();
  //document.addEventListener("mousedown", dismisscolorpalette, true);
  //document.getElementById("edit-box").contentWindow.document.addEventListener("mousedown", dismisscolorpalette, true);
 // document.addEventListener("keypress", dismisscolorpalette, true);
  //document.getElementById("edit-box").contentWindow.document.addEventListener("keypress", dismisscolorpalette, true);
}

function viewsource(source)
{
  if (source) {
    var html = document.createTextNode(document.getElementById('edit-box').contentWindow.document.body.innerHTML);
    document.getElementById('edit-box').contentWindow.document.body.innerHTML = "";
    document.getElementById('edit-box').contentWindow.document.body.appendChild(html);
   // document.getElementById("toolbar1").style.visibility="hidden";
    //document.getElementById("toolbar2").style.visibility="hidden";  
  } else {
    var html = document.getElementById('edit-box').contentWindow.document.body.ownerDocument.createRange();
    html.selectNodeContents(document.getElementById('edit-box').contentWindow.document.body);
    document.getElementById('edit-box').contentWindow.document.body.innerHTML = html.toString();
    //document.getElementById("toolbar1").style.visibility="visible";
    //document.getElementById("toolbar2").style.visibility="visible";  
  }
}

function usecss(source)
{
  document.getElementById('edit-box').contentWindow.document.execCommand("useCSS", false, source);  
}

function readonly(source)
{
    document.getElementById('edit-box').contentWindow.document.execCommand("readonly", false, source);  
}

function insertLink(x) {
document.getElementById('edit-box').contentWindow.document.execCommand("CreateLink",false,x);
}
